## xtruss 0.0~git20241011.27fafffe-1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(xtruss LANGUAGES C)

include(cmake/setup.cmake)

# Scan the docs directory first, so that when we start calling
# installed_program(), we'll know if we have man pages available
add_subdirectory(doc)

add_compile_definitions(HAVE_CMAKE_H)

add_library(utils STATIC
  ${GENERATED_COMMIT_C})
add_dependencies(utils cmake_commit_c)
add_subdirectory(utils)

add_library(eventloop STATIC
  callback.c timing.c)

add_library(console STATIC
  console.c)

add_library(crypto STATIC)
add_subdirectory(crypto)

add_library(network STATIC
  nullplug.c errsock.c noproxy.c x11disp.c)

foreach(subdir ${platform} ${extra_dirs})
  add_subdirectory(${subdir})
endforeach()

configure_file(cmake/cmake.h.in ${GENERATED_SOURCES_DIR}/cmake.h)

=== crypto/CMakeLists.txt ===
add_sources_from_current_dir(crypto
  des.c
  xdmauth.c)

=== doc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(putty-documentation LANGUAGES)

# This build script can be run standalone, or included as a
# subdirectory of the main PuTTY cmake build system. If the latter, a
# couple of things change: it has to set variables telling the rest of
# the build system what manpages are available to be installed, and it
# will change whether the 'make doc' target is included in 'make all'.

include(FindGit)
include(FindPerl)
find_program(HALIBUT halibut)

set(doc_outputs)
set(manpage_outputs)

macro(register_manpage title section)
  list(APPEND manpage_outputs ${title}.${section})
  if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    # Only set this variable if there _is_ a parent scope.
    set(HAVE_MANPAGE_${title}_${section} ON PARENT_SCOPE)
  endif()
endmacro()

macro(manpage title section)
  if(HALIBUT)
    add_custom_command(OUTPUT ${title}.${section}
      COMMAND ${HALIBUT} --man=${title}.${section}
        ${CMAKE_CURRENT_SOURCE_DIR}/mancfg.but
        ${CMAKE_CURRENT_SOURCE_DIR}/man-${title}.but
      DEPENDS
        mancfg.but man-${title}.but)
    register_manpage(${title} ${section})
  elseif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${title}.${section})
    add_custom_command(OUTPUT ${title}.${section}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
        ${CMAKE_CURRENT_SOURCE_DIR}/${title}.${section} ${title}.${section}
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${title}.${section})
    register_manpage(${title} ${section})
  endif()
endmacro()

manpage(xtruss 1)

add_custom_target(manpages ALL DEPENDS ${manpage_outputs})
add_custom_target(doc DEPENDS ${doc_outputs} manpages)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  # If we're doing a cmake from just the doc subdir, we expect the
  # user to want to make all the documentation, including HTML and so
  # forth. (What else would be the point?)
  #
  # But if we're included from the main makefile, then by default we
  # only make the man pages (which are necessary for 'make install'),
  # and we leave everything else to a separate 'make doc' target which
  # the user can invoke if they need to.
  add_custom_target(doc-default ALL DEPENDS doc)
endif()

=== unix/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

add_sources_from_current_dir(utils
  utils/block_signal.c
  utils/cloexec.c
  utils/dputs.c
  utils/filename.c
  utils/fontspec.c
  utils/getticks.c
  utils/nonblock.c
  utils/pollwrap.c
  utils/signal.c
  # We want the ISO C implementation of ltime(), because we don't have
  # a local better alternative
  ../utils/ltime.c)
add_sources_from_current_dir(eventloop
  cliloop.c uxsel.c)
add_sources_from_current_dir(console
  console.c)
add_sources_from_current_dir(network
  network.c peerinfo.c x11.c)

add_executable(xtruss
  uxxtruss.c
  ${CMAKE_SOURCE_DIR}/xtruss.c
  ${CMAKE_SOURCE_DIR}/xtruss-trace.c
  ${CMAKE_SOURCE_DIR}/xtruss-proxy.c
  ${CMAKE_SOURCE_DIR}/xtruss-record.c
  ${CMAKE_SOURCE_DIR}/norand.c)
target_link_libraries(xtruss eventloop console network utils crypto)
installed_program(xtruss)

=== utils/CMakeLists.txt ===
add_sources_from_current_dir(utils
  bufchain.c
  burnstr.c
  chomp.c
  conf.c
  debug.c
  dupcat.c
  dupprintf.c
  dupstr.c
  fgetline.c
  host_strchr.c
  host_strchr_internal.c
  host_strcspn.c
  host_strduptrim.c
  host_strrchr.c
  marshal.c
  memory.c
  nullstrcmp.c
  out_of_memory.c
  ptrlen.c
  sk_free_peer_info.c
  smemclr.c
  smemeq.c
  strbuf.c
  string_length_for_printf.c
  tree234.c
  x11authfile.c
  x11authnames.c
  x11_dehexify.c
  x11_make_greeting.c
  x11_parse_ip.c)

=== debian/changelog ===
xtruss (0.0~git20241011.27fafffe-1) unstable; urgency=medium

  * Initial upload to Debian.
  * Closes: #1087205

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 10 Nov 2024 21:27:15 +0000

=== debian/control ===
Source: xtruss
Homepage: https://www.chiark.greenend.org.uk/~sgtatham/xtruss/
Build-Depends: debhelper-compat (=13), cmake, halibut
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Vcs-Git: https://salsa.debian.org/debian/xtruss/
Priority: optional
Section: devel
Standards-Version: 4.7.0.1

Package: xtruss
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: X11 protocol trace utility
 Like strace, but for the X Window System: dumps X protocol requests
 and replies.  Works by proxying the X connection.

=== debian/tests/control ===
Depends: @, x11-utils, xvfb, xauth
Tests: xwininfo
Restrictions: allow-stderr

Depends: @, man
Tests: manpage
Restrictions: allow-stderr

## xtruss 0.0~git20241011.27fafffe-1build1

=== debian/changelog ===
xtruss (0.0~git20241011.27fafffe-1build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@debian.org>  Thu, 29 Jan 2026 22:12:30 +0100
